//------------------------------------------------------------------
#property  copyright "copyleft mladen"
//------------------------------------------------------------------
#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  LimeGreen
#property  indicator_color2  LimeGreen
#property  indicator_color3  Orange
#property  indicator_color4  Orange
#property  indicator_color5  Gray
#property  indicator_width1  2
#property  indicator_width3  2
#property  indicator_width5  2


//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT;
extern int                RsiPeriod       = 14;
extern ENUM_APPLIED_PRICE RsiPrice        = PRICE_CLOSE;
extern bool               alertsOn        = false;
extern bool               alertsOnCurrent = true;
extern bool               alertsMessage   = true;
extern bool               alertsSound     = false;
extern bool               alertsNotify    = false;
extern bool               alertsEmail     = false;
extern string             soundFile       = "alert2.wav";

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double slope[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,Buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,Buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,Buffer5);
   SetIndexBuffer(5,slope);
 
   IndicatorShortName(timeFrameToString(TimeFrame)+" RSI ("+DoubleToStr(RsiPeriod,2)+")");
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMax(Bars-counted_bars,3*TimeFrame/Period());
            
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--) 
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);             
      Buffer5[i] = iRSI(NULL,TimeFrame,RsiPeriod,RsiPrice,y)-50;

      //
      //
      //
      //
      //
      
         Buffer1[i] = EMPTY_VALUE;
         Buffer2[i] = EMPTY_VALUE;
         Buffer3[i] = EMPTY_VALUE;
         Buffer4[i] = EMPTY_VALUE;
            slope[i] = slope[i+1];
               if (Buffer5[i]>Buffer5[i+1]) slope[i] =  1;
               if (Buffer5[i]<Buffer5[i+1]) slope[i] = -1;
               if (Buffer5[i]>0)
                  if (slope[i]==1)
                        Buffer1[i] = Buffer5[i];
                  else  Buffer2[i] = Buffer5[i];
               if (Buffer5[i]<0)
                  if (slope[i]==1)
                        Buffer4[i] = Buffer5[i];
                  else  Buffer3[i] = Buffer5[i];
   }
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,TimeFrame,whichBar)); 
      
      //
      //
      //
      //
      //
      
      if (Buffer1[whichBar+1] == EMPTY_VALUE && Buffer1[whichBar] != EMPTY_VALUE) doAlert(whichBar,"buy");
      if (Buffer3[whichBar+1] == EMPTY_VALUE && Buffer3[whichBar] != EMPTY_VALUE) doAlert(whichBar,"sell");
    }         
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(TimeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Rsi histo ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Rsi histo "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}


